class AR_Display
 {
  private:

   int width,height;
   int max_fps;
   bool fullscreen;
   ALLEGRO_DISPLAY *display;

  public:

   AR_Display(int width, int height, bool fullscreen)
    {
     this->width      = width;
     this->height     = height;
     this->fullscreen = fullscreen;
     if(fullscreen) al_set_new_display_flags(ALLEGRO_FULLSCREEN);
     display = al_create_display(width,height);
     if(!display) { AR_Util::errorBox(display,"Failed to create display!"); exit(1); }    
     al_set_blender(ALLEGRO_ADD,ALLEGRO_ONE,ALLEGRO_INVERSE_ALPHA);
	}

   ~AR_Display() { } //al_destroy_display(display);...

   void fade(int r = 0, int g = 0, int b = 0, float delay = 0.004)
    {
     // Fade this display to rgb color with delay
     ALLEGRO_BITMAP *bmp;

     bmp = al_create_bitmap(1,1);
     al_set_target_bitmap(bmp);
     al_clear_to_color(al_map_rgba(r,g,b,64));
     al_set_target_bitmap(al_get_backbuffer(display));
     for(int a=0;a<=128;a++)
      {
	   al_draw_tinted_scaled_bitmap(bmp,al_map_rgba(a,a,a,a),0,0,1,1,0,0,al_get_display_width(display),al_get_display_height(display),0);
       al_flip_display();
       al_rest(delay);
	  }
	 al_destroy_bitmap(bmp);
	}

   void setMaxFPS(int max_fps) { this->max_fps = max_fps; }

   int getWidth()  { return width;   }

   int getHeight() { return height;  }

   int getMaxFPS() { return max_fps; }

   ALLEGRO_DISPLAY *getDisplay() { return display; }

 };
